﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using JqGridWithAspNet2011_12_27.helper;
using Newtonsoft.Json;

namespace JqGridWithAspNet2011_12_27.handlers
{
    public class MyOrder : IHttpHandler
    {

        public void ProcessRequest(HttpContext context)
        {
            context.Response.ContentType = "application/json";

            string sql = "select top 100 OrderID,CustomerID,ShipName,OrderDate from Orders ";
            DataTable dt = SqlHelper.ExecuteDataset(sql).Tables[0];

            IList<object> rowObjects = new List<object>();

            // 每页显示记录数
            int pageSize = 10;
            // 记录总数
            int rowCount = dt.Rows.Count;
            // 列数
            int columnCount = dt.Columns.Count;
            // 总页数
            int pageCount = rowCount%pageSize == 0 ? rowCount/pageSize : rowCount/pageSize + 1;

            int ID = 1;
            foreach (DataRow dr in dt.Rows)
            {
                var cellValue = new string[columnCount];
                for (var i = 0; i < cellValue.Length; i++)
                {
                    cellValue[i] = dr[i].ToString();
                }
                
                // 创建row对象
                var rowObj = new
                                 {
                                     id = ID,
                                     cell = cellValue
                                 };
                rowObjects.Add(rowObj);
                ID++;
            }

            var resultObj = new
                          {
                              total = pageCount,    // 总页数
                              page = 1,             // 由于客户端是loadonce的，page也可以不指定
                              records = rowCount,   // 总记录数
                              rows = rowObjects     // 数据
                          };
            string json = JsonConvert.SerializeObject(resultObj);
            context.Response.Write(json);

        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}
