﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using JqGridWithAspNet2011_12_27.helper;
using JqGridWithAspNet2011_12_27.paging;
using Newtonsoft.Json;

namespace JqGridWithAspNet2011_12_27.handlers
{

    public class MyOrder2 : IHttpHandler
    {
        public void ProcessRequest(HttpContext context)
        {
            context.Response.ContentType = "application/json";

            string sql = "select top 100 OrderID,CustomerID,ShipName,OrderDate from Orders ";
            DataTable dt = SqlHelper.ExecuteDataset(sql).Tables[0];

            // 每页显示记录数
            int pageSize = 10;
            // 记录总数
            int rowCount = dt.Rows.Count;
            // 总页数
            int pageCount = rowCount % pageSize == 0 ? rowCount / pageSize : rowCount / pageSize + 1;

            var resultObj = new DataResult
                                {
                                    // 总页数
                                    PageCount = pageCount,
                                    // 当前页
                                    PageIndex = 1,
                                    // 总记录数
                                    Total = rowCount,
                                    // 数据
                                    Data = dt 
                                };

            string resultJson = JsonHelper.Serialize(resultObj);

            context.Response.Write(resultJson);
        }

        public bool IsReusable
        {
            get { return false; }
        }
    }
}
